module Main where

import Test.QuickCheck

{-
As an example, we show that "Either Integer Bool" is isomorphic to "Either Bool Integer".
Note that the tests are just functions into Bool. If the functions are implemented correctly,
then they should always return true.
-}
eBoolInt2eIntBool :: Either Bool Integer -> Either Integer Bool
eBoolInt2eIntBool (Left b) = Right b
eBoolInt2eIntBool (Right i) = Left i

eIntBool2eBoolInt :: Either Integer Bool -> Either Bool Integer
eIntBool2eBoolInt (Left i) = Right i
eIntBool2eBoolInt (Right b) = Left b

prop_test1a :: Either Bool Integer -> Bool
prop_test1a x = (eIntBool2eBoolInt . eBoolInt2eIntBool) x == id x
prop_test1b :: Either Integer Bool -> Bool
prop_test1b x = (eBoolInt2eIntBool . eIntBool2eBoolInt) x == id x

{-
Show that "Integer" is isomorphic to "Either Integer Integer".
-}
int2SumOfInt :: Integer -> Either Integer Integer
int2SumOfInt = undefined

sumOfInt2Int :: Either Integer Integer -> Integer
sumOfInt2Int = undefined

prop_test2a :: Integer -> Bool
prop_test2a x = (sumOfInt2Int . int2SumOfInt) x == id x
prop_test2b :: Either Integer Integer -> Bool
prop_test2b x = (int2SumOfInt . sumOfInt2Int) x == id x

{-
Show that "Integer" is isomorphic to "Maybe Integer".
-}
int2MaybeInt :: Integer -> Maybe Integer
int2MaybeInt = undefined

maybeInt2Int :: Maybe Integer -> Integer
maybeInt2Int = undefined

prop_test3a :: Integer -> Bool
prop_test3a x = (maybeInt2Int . int2MaybeInt) x == id x
prop_test3b :: Maybe Integer -> Bool
prop_test3b x = (int2MaybeInt . maybeInt2Int) x == id x

{-
Show that "Integer" is isomorphic to a list of units "[()]".
-}
int2ListOfUnit :: Integer -> [()]
int2ListOfUnit = undefined

listOfUnit2Int :: [()] -> Integer
listOfUnit2Int = undefined

prop_test4a :: Integer -> Bool
prop_test4a x = (listOfUnit2Int . int2ListOfUnit) x == id x
prop_test4b :: [()] -> Bool
prop_test4b x = (int2ListOfUnit . listOfUnit2Int) x == id x

{-
Show that "Integer" is isomorphic to "(Integer, Integer)".
Note: This exercise is more complicated and therefore optional. If you want
to solve it, google for "Cantorsche Paarungsfunktion" and combine that function
with an isomorphism between natural numbers and integers.
-}
int2PairOfInt :: Integer -> (Integer,Integer)
int2PairOfInt = undefined

pairOfInt2Int :: (Integer,Integer) -> Integer
pairOfInt2Int = undefined

prop_test5a :: Integer -> Bool
prop_test5a x = (pairOfInt2Int . int2PairOfInt) x == id x
prop_test5b :: (Integer, Integer) -> Bool
prop_test5b x = (int2PairOfInt . pairOfInt2Int) x == id x

{-
Main contains all our tests. Uncomment the tests that you want to run.
-}
main :: IO ()
main = do
  quickCheck prop_test1a
  quickCheck prop_test1b
  -- quickCheck prop_test2a
  -- quickCheck prop_test2b
  -- quickCheck prop_test3a
  -- quickCheck prop_test3b
  -- quickCheck prop_test4a
  -- quickCheck prop_test4b
  -- quickCheck prop_test5a
  -- quickCheck prop_test5b
